//+------------------------------------------------------------------+
//|                                    bless_FiFtHeLeMeNt_noTG_1.0.1 |
//|                                   Copyright  2007, FiFtHeLeMeNt |
//|                                         fifthelement80@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, FiFtHeLeMeNt."
#property link      "http://www.irxfx.com"

extern int MinGS=20;
extern int TP=27;
extern double lot=0.01;
extern int MaxTrades=7;
extern int magic=411928;
extern double SL=150;
double lot2;
datetime tob,tos; //Time Out Buy & Sell

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----


   
//----
   return(0);
  }
  
int init()
  {
   if (Symbol() == "AUDCADm" || Symbol() == "AUDCADFXF") { magic = 411001; }
   if (Symbol() == "AUDJPYm" || Symbol() == "AUDJPYFXF") { magic = 411002; }
   if (Symbol() == "AUDNZDm" || Symbol() == "AUDNZDFXF") { magic = 411003; }
   if (Symbol() == "AUDUSDm" || Symbol() == "AUDUSDFXF") { magic = 411004; }
   if (Symbol() == "CHFJPYm" || Symbol() == "CHFJPYFXF") { magic = 411930; }
   if (Symbol() == "EURAUDm" || Symbol() == "EURAUDFXF") { magic = 411006; }
   if (Symbol() == "EURCADm" || Symbol() == "EURCADFXF") { magic = 411007; }
   if (Symbol() == "EURCHFm" || Symbol() == "EURCHFFXF") { magic = 411008; }
   if (Symbol() == "EURGBPm" || Symbol() == "EURGBPFXF") { magic = 411009; }
   if (Symbol() == "EURJPYm" || Symbol() == "EURJPYFXF") { magic = 411010; }
   if (Symbol() == "EURUSDm" || Symbol() == "EURUSDFXF") { magic = 411929; }
   if (Symbol() == "GBPCHFm" || Symbol() == "GBPCHFFXF") { magic = 411012; }
   if (Symbol() == "GBPJPYm" || Symbol() == "GBPJPYFXF") { magic = 411013; }
   if (Symbol() == "GBPUSDm" || Symbol() == "GBPUSDFXF") { magic = 411014; }
   if (Symbol() == "NZDJPYm" || Symbol() == "NZDJPYFXF") { magic = 411015; }
   if (Symbol() == "NZDUSDm" || Symbol() == "NZDUSDFXF") { magic = 411016; }
   if (Symbol() == "USDCHFm" || Symbol() == "USDCHFFXF") { magic = 411017; }
   if (Symbol() == "USDJPYm" || Symbol() == "USDJPYFXF") { magic = 411928; }
   if (Symbol() == "USDCADm" || Symbol() == "USDCADFXF") { magic = 411019; }
   if (magic == 0) { magic = 411999; }
   return (0);
   return(0);
  }

void OpenBuy()
 {
    int ticket,err;
        if (!GlobalVariableCheck("InTrade")) {
               GlobalVariableSet("InTrade", CurTime());  // set lock indicator
               ticket = OrderSend(Symbol(),OP_BUY,lot2,Ask,1, Ask - SL * Point, Ask + TP * Point,"textraders",magic,0,Blue);
               GlobalVariableDel("InTrade");   // clear lock indicator
        }
 }

void OpenSell()
 {
    int ticket,err;
        if (!GlobalVariableCheck("InTrade")) {
               GlobalVariableSet("InTrade", CurTime());  // set lock indicator
               ticket = OrderSend(Symbol(),OP_SELL,lot2,Bid,1, Bid + SL * Point, Bid - TP * Point,"textraders",magic,0,Red);
               GlobalVariableDel("InTrade");   // clear lock indicator
        }
 }


void ManageBuy() 
 {
   int lasttradetime = 0;
   double lastopenprice=0;
   double maxlots = 0;
   double lasttp=0;
   double lastsl=0;
   int lastordertype=-1;
   int lastorderticket=0;
   int y=0; 

   for (y = 0; y < OrdersTotal(); y++)
   {
      OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
      if ((OrderMagicNumber() != magic) || (OrderType()!=OP_BUY)) { continue; }
      if (OrderOpenTime() > lasttradetime) { 
        lasttradetime = OrderOpenTime();
        lastopenprice = OrderOpenPrice();
        lastordertype=OrderType();
        lastorderticket=OrderTicket();
        lasttp=OrderTakeProfit();
        lastsl=OrderStopLoss();
      }     
      if (OrderLots() > maxlots) { maxlots = OrderLots(); }
   }
   
   int lvl=MathLog(maxlots/lot)/MathLog(2)+1;

   if (lvl<0) lvl=0;
   
   lot2=lot*MathPow(2,lvl);
   
   if (lvl==0) OpenBuy();
   
   if ((lastopenprice-Ask>MinGS*Point) && (lvl<MaxTrades)) {
     OpenBuy();
     return(0);
   }

/////////// TP
/*
   double sumlots=0;
   double sump=0;
   double avgp=0;
   for (y = 0; y < OrdersTotal(); y++)
   {
      OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
      if ((OrderMagicNumber() != magic) || (OrderType()!=OP_BUY)) { continue; }
      sumlots=sumlots+OrderLots();
      sump=OrderOpenPrice()*OrderLots()+sump;
   }
   
   if (sumlots>0) {
     avgp=NormalizeDouble(sump/sumlots,Digits);
     double tpp=NormalizeDouble(TP/10/sumlots*Point+avgp,Digits);
     
     for (y = 0; y < OrdersTotal(); y++)
     {
       OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
       if ((OrderMagicNumber() != magic) || (OrderType()!=OP_BUY) || (OrderTakeProfit()==tpp)) { continue; }
       OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tpp,0,Red);
     }
     
     
   }
 */  

     for (y = 0; y < OrdersTotal(); y++)
     {
       OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
       if ((OrderMagicNumber() != magic) || (OrderType()!=OP_BUY) || (OrderTakeProfit()==lasttp) || (lasttp==0) || (OrderStopLoss()==lastsl) || (lastsl==0)) { continue; }
       OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),lasttp,lastsl,Blue);
     }

   
}
    
void ManageSell() 
 {
   int lasttradetime = 0;
   double lastopenprice=0;
   double maxlots = 0;
   double lasttp=0;
   double lastsl=0;
   int lastordertype=-1;
   int lastorderticket=0;
   int y=0; 

   for (y = 0; y < OrdersTotal(); y++)
   {
      OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
      if ((OrderMagicNumber() != magic) || (OrderType()!=OP_SELL)) { continue; }
      if (OrderOpenTime() > lasttradetime) { 
        lasttradetime = OrderOpenTime();
        lastopenprice = OrderOpenPrice();
        lastordertype=OrderType();
        lastorderticket=OrderTicket();
        lasttp=OrderTakeProfit();
        lastsl=OrderStopLoss();
      }     
      if (OrderLots() > maxlots) { maxlots = OrderLots(); }
   }
   
   int lvl=MathLog(maxlots/lot)/MathLog(2)+1;

   if (lvl<0) lvl=0;
   
   lot2=lot*MathPow(2,lvl);
   
   if (lvl==0) OpenSell();
   
   if ((Bid-lastopenprice>MinGS*Point) && (lastopenprice>0) && (lvl<MaxTrades)) {
     OpenSell();
     return(0);
   }

/////////// TP
/*   double sumlots=0;
   double sump=0;
   double avgp=0;
   for (y = 0; y < OrdersTotal(); y++)
   {
      OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
      if ((OrderMagicNumber() != magic) || (OrderType()!=OP_SELL)) { continue; }
      sumlots=sumlots+OrderLots();
      sump=OrderOpenPrice()*OrderLots()+sump;
   }
   
   if (sumlots>0) {
     avgp=NormalizeDouble(sump/sumlots,Digits);
     double tpp=NormalizeDouble(-TP/10/sumlots*Point+avgp,Digits);
     
     for (y = 0; y < OrdersTotal(); y++)
     {
       OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
       if ((OrderMagicNumber() != magic) || (OrderType()!=OP_SELL) || (OrderTakeProfit()==tpp)) { continue; }
       OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tpp,0,Red);
     }
     
     
   }
 */ 
 
      for (y = 0; y < OrdersTotal(); y++)
     {
       OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
       if ((OrderMagicNumber() != magic) || (OrderType()!=OP_SELL) || (OrderTakeProfit()==lasttp) || (lasttp==0) || (OrderStopLoss()==lastsl) || (lastsl==0)) { continue; }
       OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),lasttp,lastsl,Red);
     }
 
   
 }

  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

  ManageBuy();
  
  ManageSell();


   
//----
   return(0);
  }
//+------------------------------------------------------------------+